## mia 2.4.6

=== CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

PROJECT("mia")

# now need OBJECT libraries 
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.8 FATAL_ERROR)

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0012 NEW)
  IF(${CMAKE_VERSION} VERSION_GREATER 3.0.0) 
    cmake_policy(SET CMP0042 NEW)
  ENDIF()
endif(COMMAND cmake_policy)

# This test is added for the Ninja generator, since it 
# has problems with relinking when installing 
# 
STRING(COMPARE EQUAL "${CMAKE_SYSTEM_NAME}" "Linux" SYSTEM_IS_LINUX)
IF(${SYSTEM_IS_LINUX})
  SET(CMAKE_EXECUTABLE_FORMAT "ELF")
ENDIF()

include(FindPkgConfig)
include(CheckCXXSourceCompiles)

# Making releases:
#   MICRO_VERSION += 1;
#   INTERFACE_AGE += 1;
#   BINARY_AGE += 1;
# if any functions have been added, set INTERFACE_AGE to 0.
# if backwards compatibility has been broken,
# set BINARY_AGE and INTERFACE_AGE to 0.


SET(VENDOR "Gert Wollny")
SET(PACKAGE_NAME "mia")
SET(MAJOR_VERSION 2)
SET(MINOR_VERSION 4)
SET(MICRO_VERSION 6)
SET(INTERFACE_AGE 0)
SET(BINARY_AGE    0)

#
#SET(CMAKE_BUILD_WITH_INSTALL_RPATH 1)

SET(PACKAGE_VERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${MICRO_VERSION}")
SET(VERSION "${MAJOR_VERSION}.${MINOR_VERSION}")
SET(MIA_NAME "${PACKAGE_NAME}-${VERSION}")
SET(prefix ${CMAKE_INSTALL_PREFIX})
SET(PLUGIN_OUTPUT "${CMAKE_BINARY_DIR}/plugins")

SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

MATH(EXPR MIA_CURRENT "${MICRO_VERSION} - ${BINARY_AGE}")
SET(MIA_REVISION ${INTERFACE_AGE})
MATH(EXPR MIA_AGE "${BINARY_AGE} - ${INTERFACE_AGE}")

SET(LIBRARY_SOVERSION_INFO "${MIA_CURRENT}")
SET(LIBRARY_VERSION_INFO "${MIA_CURRENT}.${MIA_AGE}.${MIA_REVISION}")

OPTION(STRICT_DEPENDECIES "require that all requested optinal dependencies are availabe" FALSE)
OPTION(ALWAYS_CREATE_DOC "Create all documentation during the normal build process (normally you need to run 'make doc')" TRUE)
OPTION(BUILD_EXAMPLES "Build example plug-ins and programs" FALSE)
OPTION(ENABLE_DEBUG_MESSAGES "Enable debug and trace outputs" TRUE)
OPTION(ENABLE_COVERAGE "Enable code coverage tests" FALSE)
OPTION(DISABLE_PROGRAMS "Don't build the programs nor documentation (only for testing purposes)" FALSE)
OPTION(MIA_CREATE_USERDOC "Enable creation of html user documentation" TRUE)
OPTION(MIA_ENABLE_TESTING "Enable compiling and running the test suite" TRUE)



INCLUDE(GNUInstallDirs)

INCLUDE (CheckIncludeFiles)
INCLUDE (TestBigEndian)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/macros.cmake)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/pluginmacro.cmake)
INCLUDE (CheckTypeSize)
INCLUDE (CheckIncludeFileCXX)

include(CheckCXXCompilerFlag)


MESSAGE(STATUS "Compiler is ${CMAKE_CXX_COMPILER_ID} version ${CMAKE_CXX_COMPILER_VERSION}")

IF (((${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU") AND
      (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 5.3.0)) OR
    ((${CMAKE_CXX_COMPILER_ID} STREQUAL "Clang") AND
      (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 3.3.0)))
  MESSAGE(STATUS "Compiler  has full c++11 support")

  # g++ >= 6.0 sets std=c++14 by default
  IF ((${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU") AND
      (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 6.0.0))  
    SET(CXX_11_FLAG "-std=c++11")
  ENDIF()
  
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  ${CXX_11_FLAG} -fvisibility=hidden")
ELSE()
  CHECK_CXX_COMPILER_FLAG("-std=c++11" HAS_GNU_CXX11_FLAG)
  IF(HAS_GNU_CXX11_FLAG)
    SET(CXX_11_FLAG "-std=c++11")
  ELSE(HAS_GNU_CXX11_FLAG)
    CHECK_CXX_COMPILER_FLAG("-std=c++0x" HAS_GNU_CXX0X_FLAG)
    IF(HAS_GNU_CXX0X_FLAG)
      SET(CXX_11_FLAG "-std=c++0x")
    ELSE(HAS_GNU_CXX0X_FLAG)
      MESSAGE(WARNING "Don't know how to enable C++11, if you are lucky, they are enabled by default")
    ENDIF(HAS_GNU_CXX0X_FLAG)
  ENDIF(HAS_GNU_CXX11_FLAG)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  ${CXX_11_FLAG} -fvisibility=hidden")
  INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkCpp0xAuto.cmake)
  INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkCpp0xLambda.cmake)
  IF(NOT "${CXX_HAS_CXX_0X_AUTO}" OR NOT CXX_HAS_CXX_0X_LAMBDA)
    MESSAGE(FATAL_ERROR 
      "This source code requires the C++0x auto type and lambda features. "
      "If your compiler is supposed to support this feature, "
      "please enable the appropriate flags and delete the CMakeCache.txt file before "
      "re-running cmake.\n"
      "For g++ >= 4.8 this is '-std=c++0x' ")
  ENDIF(NOT "${CXX_HAS_CXX_0X_AUTO}" OR NOT CXX_HAS_CXX_0X_LAMBDA)
ENDIF()

# older versions of g++ libstdc++ don't implement regex sufficiently good
# to be useful
IF ((${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU") AND
    (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 5.3.0))
  SET(MIA_USE_BOOST_REGEX_PRESET FALSE)
ELSE()
  SET(MIA_USE_BOOST_REGEX_PRESET TRUE)
ENDIF()
  
OPTION(MIA_USE_BOOST_REGEX "Use the boost::regex library (instead of c++11 build in) " ${MIA_USE_BOOST_REGEX_PRESET})

IF (ENABLE_COVERAGE)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage -O0 -g -DMIA_COVERAGE")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} --coverage")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage")
ENDIF()

INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkSSEAttributeVectorCanUseSubscript.cmake)

INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkAltivecEnabled.cmake)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkSSEEnabled.cmake)

ASSERT_SIZE(char 1)
ASSERT_SIZE(short 2)
ASSERT_SIZE(int 4)
ASSERT_SIZE(float 4)
ASSERT_SIZE(double 8)

CHECK_TYPE_SIZE(long LONG_TYPE_SIZE)


IF (${LONG_TYPE_SIZE} EQUAL 8)
  SET(LONG_64BIT TRUE)
ELSE(${LONG_TYPE_SIZE} EQUAL 8)
  SET(LONG_64BIT FALSE)
ENDIF(${LONG_TYPE_SIZE} EQUAL 8)

TEST_BIG_ENDIAN(WORDS_BIGENDIAN)
CHECK_INCLUDE_FILES (unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILES (sys/ioctl.h HAVE_SYS_IOCTL_H)
CHECK_INCLUDE_FILES (execinfo.h HAVE_EXEINFO_H)


CHECK_INCLUDE_FILE_CXX (cxxabi.h HAVE_CXXABI_H)


# find additional packages
#
# With MSVC using pre-installed dynamic libraries is usually a pain because of
# the incompatibilities in the compiler flags
#
IF (MSVC)
  SET(SEARCH_LIBS_DEFAULT FALSE)
ELSE(MSVC)
  SET(SEARCH_LIBS_DEFAULT TRUE)
ENDIF (MSVC)




# Taken from ITK:
# On Visual Studio 8 MS deprecated C. This removes all 1.276E1265 security
# warnings
IF(MSVC)
  ADD_DEFINITIONS(
    -D_CRT_FAR_MAPPINGS_NO_DEPRECATE
    -D_CRT_IS_WCTYPE_NO_DEPRECATE
    -D_CRT_MANAGED_FP_NO_DEPRECATE
    -D_CRT_NONSTDC_NO_DEPRECATE
    -D_CRT_SECURE_NO_DEPRECATE
    -D_CRT_SECURE_NO_DEPRECATE_GLOBALS
    -D_CRT_SETERRORMODE_BEEP_SLEEP_NO_DEPRECATE
    -D_CRT_TIME_FUNCTIONS_NO_DEPRECATE
    -D_CRT_VCCLRIT_NO_DEPRECATE
    -D_SCL_SECURE_NO_DEPRECATE
    -D_SECURE_SCL=0
    )
ENDIF(MSVC)

SET(SOURCE_ROOT "${CMAKE_CURRENT_SOURCE_DIR}")
SET(BUILD_ROOT "${CMAKE_CURRENT_BINARY_DIR}")
SET(LIB_ROOT_INSTALL_PATH "${CMAKE_INSTALL_FULL_LIBDIR}/${MIA_NAME}")
SET(CONFIG_INSTALL_PATH "${LIB_ROOT_INSTALL_PATH}/config")
SET(LIB_INCLUDE_INSTALL_PATH "${LIB_ROOT_INSTALL_PATH}/include")
SET(PLUGIN_INSTALL_PATH "${LIB_ROOT_INSTALL_PATH}/plugins")
SET(PLUGIN_SEARCH_PATH "${PLUGIN_INSTALL_PATH}")
SET(DOC_INSTALL_PATH "share/doc/${MIA_NAME}")
SET(FULL_DOC_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${DOC_INSTALL_PATH}")
SET(BINARY_INSTALL_PATH "${CMAKE_INSTALL_BINDIR}")
SET(LIBRARY_INSTALL_PATH "${CMAKE_INSTALL_LIBDIR}")
SET(INCLUDE_INSTALL_PATH "${CMAKE_INSTALL_INCLUDEDIR}/${MIA_NAME}")
SET(MIA_DOCTOOLS_INSTALL_ROOT "${CMAKE_INSTALL_PREFIX}/share/mia-doctools")

######################################################################################
#
# Handle BOOST
#
#
MACRO(GET_BOOST_LINKERFLAG VAR LIBNAMES)
  FOREACH(L  ${LIBNAMES})
    STRING(REGEX MATCH "boost_[-_a-z0-9]*" temp ${L})
    STRING(LENGTH "${temp}" TEMP_LENGTH)
    IF(${TEMP_LENGTH})
      SET(flags "${flags} -l${temp}")
    ENDIF(${TEMP_LENGTH})
  ENDFOREACH(L  ${LIBNAMES})
  
  SET(${VAR} "${flags}")
ENDMACRO(GET_BOOST_LINKERFLAG)

SET(BOOST_COMPONENTS filesystem  unit_test_framework serialization system)

IF (MIA_USE_BOOST_REGEX)
  SET(BOOST_COMPONENTS  ${BOOST_COMPONENTS} regex)
ENDIF()

IF (WIN32)
  SET(BOOST_COMPONENTS  ${BOOST_COMPONENTS} date_time)
ENDIF(WIN32)

FIND_PACKAGE( Boost 1.50.0 COMPONENTS
  ${BOOST_COMPONENTS}
  REQUIRED)

INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})

ADD_DEFINITIONS(-DBOOST_ALL_DYN_LINK)
ADD_DEFINITIONS(-DBOOST_FILESYSTEM_VERSION=3)

IF (MIA_USE_BOOST_REGEX)
  SET(BOOST_DEPS ${Boost_REGEX_LIBRARY}  ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
ELSE()
  SET(BOOST_DEPS ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
ENDIF()

SET(BOOST_UNITTEST  ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})

IF (WIN32 AND NOT UNIX)
   FOREACH(l 
       ${Boost_REGEX_LIBRARIES}
       ${Boost_FILESYSTEM_LIBRARY}
       ${Boost_SYSTEM}
       ${Boost_DATE_TIME}
       )
      STRING(REGEX MATCH "lib$" head ${l})
      STRING(COMPARE EQUAL "xlib" "x${head}" islib)
      IF (${islib})
	  STRING(REGEX REPLACE "lib$" "dll" lDLL ${l})
	  INSTALL(FILES ${lDLL} DESTINATION "bin")
      ENDIF(${islib})
   ENDFOREACH(l)
ENDIF (WIN32 AND NOT UNIX)

IF (MSYS OR MINGW)
  SET(BASELIBS ${BOOST_DEPS})
ENDIF (MSYS OR MINGW)

#
# end BOOST 
#
################################################################################

################################################################################
#
# Intel Threading Building Blocks 
#
OPTION(WITH_TBB "Use intel threading building blocks for threading, otherwise use c++11 threads" OFF)

IF(WITH_TBB) 
  FIND_PACKAGE(TBB REQUIRED)
  IF(TBB_FOUND) 
    include_directories(${TBB_INCLUDE_DIRS})
    link_directories(${TBB_LIBRARY_DIRS})
    SET(HAVE_TBB 1)
  ELSE(TBB_FOUND) 
    MESSAGE(FATAL " TBB not found")
  ENDIF(TBB_FOUND)
ENDIF()
#
# End Intel Threading Building Blocks 
#
################################################################################

################################################################################
#
# Intel Threading Building Blocks 
# why is this here? 

SET(CMAKE_THREAD_PREFER_PTHREAD ON) 
FIND_PACKAGE(Threads)

IF(CMAKE_USE_PTHREADS_INIT)
  set(PTHREADLIB -lpthread)
ENDIF(CMAKE_USE_PTHREADS_INIT)

################################################################################
# 
# Handle the GNU Scientific Library, this might be a showstopper 
# on MS windows when using Visual C++ 
#
PKG_CHECK_MODULES(GSL REQUIRED gsl)
INCLUDE_DIRECTORIES(${GSL_INCLUDE_DIRS})
LINK_DIRECTORIES(${GSL_LIBRARY_DIRS})


PKG_CHECK_MODULES(EIGEN3 REQUIRED eigen3)
INCLUDE_DIRECTORIES(${EIGEN3_INCLUDE_DIRS})
LINK_DIRECTORIES(${EIGEN3_LIBRARY_DIRS})


IF(UNIX)
  GET_BOOST_LINKERFLAG(BOOST_LIBFLAG "${BOOST_DEPS}")
  SET(MIA_DEPEND_LIBRARIES "${BOOST_LIBFLAG} ${TBB_LIBRARIES} ${PTHREADLIB} -ldl")
ENDIF(UNIX)

##################################################################################
#
# Find gzip for man page compression 
#
find_program(GZIP gzip)
IF(NOT GZIP) 
  MESSAGE(gzip not found, man pages will not be compressed)
ENDIF(NOT GZIP) 

##################################################################################
#
# take care of modules loading infrastructure
#
IF(NOT WIN32)

  FIND_LIBRARY(DL dl
    PATH
    /lib
    /usr/lib
    /opt/local/lib
    /sw/lib
  )
  IF(DL_NOTFOUND)

=== doc/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#


INCLUDE (${CMAKE_ROOT}/Modules/FindDoxygen.cmake)


ADD_CUSTOM_TARGET(docs echo "creating documentation")
add_dependencies(doc docs)  

SET(MIADOCTOOLS_FILES 
  miareadxml.py  
  miawritprogram.py  
  MiaDoctools.cmake
  __init__.py
  )

SET(MIADOCTOOLS_PYTHON_EXE
  miaxml2man.py  
  miaxml2nipype.py  
  miaxml2sgml.py
  )


IF(MIA_CREATE_USERDOC) 

  INSTALL(FILES ${MIADOCTOOLS_FILES} DESTINATION ${MIA_DOCTOOLS_INSTALL_ROOT})
  
  INSTALL(PROGRAMS ${MIADOCTOOLS_PYTHON_EXE} DESTINATION ${MIA_DOCTOOLS_INSTALL_ROOT})

  ##################################################################
  #  for html userref xsltproc and the style sheet is needed
  #
  find_program(XSLTPROC xsltproc)
  IF(XSLTPROC)
    FIND_PATH(HTML_CHUNK_FILEPATH chunk.xsl
      PATHS 
      /usr/share/sgml/docbook/xsl-stylesheets/html/
      /usr/share/xml/docbook/stylesheet/docbook-xsl/html/
      DOC "style sheet for the creation of the user reference"
      )
  ELSE (XSLTPROC)
    IF(STRICT_DEPENDECIES)
      MESSAGE(ERROR ": xsltproc not found and STRICT_DEPENDECIES set")
    ENDIF(STRICT_DEPENDECIES)
  ENDIF(XSLTPROC)
  
  IF(HTML_CHUNK_FILEPATH) 
    #
    # handle the linking of some files to run the 
    # 
    ADD_CUSTOM_TARGET(userref_outdir mkdir -p ${CMAKE_CURRENT_BINARY_DIR}/userref)
    ADD_CUSTOM_TARGET(userref_css 
      cp  ${CMAKE_CURRENT_SOURCE_DIR}/progref.css 
      ${CMAKE_CURRENT_BINARY_DIR}/userref/progref.css DEPENDS userref_outdir)

    ADD_CUSTOM_COMMAND(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/progref.xml
      COMMAND ln ARGS -sf ${CMAKE_CURRENT_SOURCE_DIR}/progref.xml ${CMAKE_CURRENT_BINARY_DIR}/progref.xml) 

    ADD_CUSTOM_TARGET(progref_link DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/progref.xml)

    ADD_CUSTOM_COMMAND(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/program.xml 
      COMMAND ${PYTHON_EXECUTABLE} ARGS ${CMAKE_CURRENT_SOURCE_DIR}/miaxml2sgml.py ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR}
      DEPENDS xmldoc
      )
    
    ADD_CUSTOM_TARGET(process_xml DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/program.xml)

      
    ADD_CUSTOM_COMMAND(OUTPUT  "userref.stamp"
      COMMAND  
      ${XSLTPROC} ARGS 
      --param chunk.section.depth 3 
      --param chunk.first.sections 1 
      --param use.id.as.filename 1 
      --stringparam html.stylesheet  progref.css 
      --output "userref/" 
      ${HTML_CHUNK_FILEPATH}/chunk.xsl progref.xml
      COMMAND touch ARGS userref.stamp
      DEPENDS process_xml userref_css userref_outdir progref_link ${CMAKE_CURRENT_BINARY_DIR}/program.xml ) 
    
    ADD_CUSTOM_TARGET(userref DEPENDS userref.stamp)
    add_dependencies(docs userref)
    
    ####################################################
    #
    # installation of the user reference 
    IF(ALWAYS_CREATE_DOC)
      INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/userref DESTINATION ${DOC_INSTALL_PATH}/)
      CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/mia2-doc.desktop.cmake ${CMAKE_CURRENT_BINARY_DIR}/mia2-doc.desktop)
      INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/mia2-doc.desktop DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)
    ENDIF(ALWAYS_CREATE_DOC)     
  ENDIF(HTML_CHUNK_FILEPATH) 
  
ENDIF(MIA_CREATE_USERDOC)

OPTION(DOXYGEN_USE_MATHJAX "Use mathjax for formulas in html documentation" ON)

IF (DOXYGEN_FOUND)
  ADD_CUSTOM_TARGET(LibraryDoc echo "creating user library documentation")
  ADD_DEPENDENCIES(docs LibraryDoc)
  
  IF(DOXYGEN_DOT_FOUND)
    SET(HAVE_DOT YES)
  ENDIF(DOXYGEN_DOT_FOUND)

  IF(DOXYGEN_USE_MATHJAX)
    SET(USE_MATHJAX YES)
    FIND_PATH(MATHJAX_CODEFILE MathJax.js
      PATHS
      /usr/share/mathjax/
      /usr/share/javascript/
      /usr/share/javascript/mathjax/
      )
    IF(NOT MATHJAX_CODEFILE)
      MESSAGE(STATUS "No mathjax installation found, Doxygen will create the documentation linking to the on-line version") 
    ENDIF()
  ENDIF()
  
  CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/reference.dox.cmake 
    ${CMAKE_CURRENT_BINARY_DIR}/reference.dox)
  
  ADD_CUSTOM_COMMAND(SOURCE COMMAND ${DOXYGEN_EXECUTABLE}
    ARGS  "${CMAKE_CURRENT_BINARY_DIR}/reference.dox"
    TARGET LibraryDoc
    OUTPUTS libdoc)
  
  IF(ALWAYS_CREATE_DOC) 
    INSTALL(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/libdoc/html/ DESTINATION ${DOC_INSTALL_PATH}/libdoc/)
    CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/libmia2-doc.desktop.cmake ${CMAKE_CURRENT_BINARY_DIR}/libmia2-doc.desktop)
    INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/libmia2-doc.desktop DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications)
  ENDIF(ALWAYS_CREATE_DOC)     
 
ENDIF (DOXYGEN_FOUND)

=== examples/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})

ADD_SUBDIRECTORY(2d)

=== octave/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

FIND_PROGRAM(MKOCTFILE mkoctfile)
SET(OCTSRC miaoct.cc)
IF(MKOCTFILE_FOUND)

  

  ADD_CUSTOM_COMMAND(OUTPUT miaoct COMMAND ${MKOCTFILE} 
    
    ${OCTSRC})


ENDIF(MKOCTFILE_FOUND)

=== addons/png/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

OPTION(WITH_PNG "enable support for PNG gray scale images IO and RGB saving" ${SEARCH_LIBS_DEFAULT})

IF (WITH_PNG)
  IF(STRICT_DEPENDECIES)
    FIND_PACKAGE(PNG REQUIRED)
  ELSE(STRICT_DEPENDECIES)
    FIND_PACKAGE(PNG)
  ENDIF(STRICT_DEPENDECIES)
ENDIF(WITH_PNG)


IF(PNG_FOUND)

  DEFINE_PROPERTY(GLOBAL PROPERTY HAVE_PNG_PROP BRIEF_DOCS "yeah" FULL_DOCS "yeah")

  SET(PNG_LINK_LIBS mia2d ${PNG_LIBRARIES})
  INCLUDE_DIRECTORIES(${PNG_PNG_INCLUDE_DIR})

  PLUGIN_WITH_PREFIX2("2dimage" "io" png-gray "${PNG_LINK_LIBS}")
  PLUGIN_WITH_PREFIX2("rgbimage" "io" png-rgb "${PNG_LINK_LIBS}" )

  NEW_TEST(png mia2d)
 

ENDIF(PNG_FOUND)

=== addons/tiff/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

OPTION(WITH_TIFF "enable support for TIFF gray scale images IO and RGB saving" ${SEARCH_LIBS_DEFAULT})

IF(WITH_TIFF)
  IF(STRICT_DEPENDECIES)
    FIND_PACKAGE(TIFF REQUIRED)
  ELSE(STRICT_DEPENDECIES)
    FIND_PACKAGE(TIFF)
  ENDIF(STRICT_DEPENDECIES)
ENDIF(WITH_TIFF)

IF(TIFF_FOUND)
  DEFINE_PROPERTY(GLOBAL PROPERTY HAVE_TIFF_PROP BRIEF_DOCS "yeah" FULL_DOCS "yeah")
  SET(TIFF_LINK_LIBS mia2d ${TIFF_LIBRARIES})
  PLUGIN_WITH_PREFIX2("2dimage" "io" tiff "${TIFF_LINK_LIBS}")
  INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})

  NEW_TEST(tiff mia2d)
ENDIF(TIFF_FOUND)

=== examples/2d/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#


ADD_SUBDIRECTORY(filter)

=== mia/2d/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

SET(MIA2D_SRC_BASE
  angle.cc
  boundingbox.cc
  correlation_weight.cc 
  cost.cc
  creator.cc
  cstkernel.cc 
  datafield.cc
  distance.cc
  filter.cc
  image.cc
  imageio.cc
  interpolator.cc 
  fftkernel.cc
  fuzzyseg.cc
  fuzzyclustersolver_sor.cc
  fuzzyclustersolver_cg.cc
  fullcost.cc
  maskedcost.cc 
  model.cc
  morphshape.cc
  multicost.cc
  nfg.cc
  nonrigidregister.cc 
  polygon.cc
  ppmatrix.cc
  rgbimageio.cc
  rigidregister.cc
  shape.cc
  similarity_profile.cc
  sparse_image_solver.cc
  splinetransformpenalty.cc
  timestep.cc
  trackpoint.cc
  transform.cc
  transformio.cc
  transformfactory.cc
  vectorfield.cc
  vfio.cc
  vfregularizer.cc
  vfregularizerkernel.cc
  )


SET(SEG_SRC 
  segframe.cc 
  segpoint.cc 
  segsection.cc 
  segset.cc
  segsetwithimages.cc
  segstar.cc 
  )
SET(SEG_HEADER 
  segpoint.hh
  segstar.hh
  segsection.hh
  segframe.hh
  segset.hh
  segsetwithimages.hh
  )

SET(MIA2D_SRC ${MIA2D_SRC_BASE} ${MIA2D_FFTW_CODE})

SET(MIA2D_HEADERS_BASE
  angle.hh
  boundingbox.hh
  cost.hh
  correlation_weight.hh 
  creator.hh
  cstkernel.hh 
  datafield.hh datafield.cxx
  defines2d.hh
  deformer.hh
  distance.hh
  fftkernel.hh
  filter.hh
  fullcost.hh
  fuzzyseg.hh
  fuzzyclustersolver_sor.hh
  fuzzyclustersolver_cg.hh
  ground_truth_evaluator.hh
  groundtruthproblem.hh
  image.hh
  imageio.hh
  imageiotest.hh
  interpolator.hh interpolator.cxx
  iterator.hh
  iterator.cxx
  matrix.hh
  maskedcost.hh 
  model.hh
  morphshape.hh
  multicost.hh
  nonrigidregister.hh
  nfg.hh
  perfusion.hh
  polygon.hh
  ppmatrix.hh
  rgbimageio.hh
  rigidregister.hh
  shape.hh
  similarity_profile.hh
  sparse_image_solver.hh
  splinetransformpenalty.hh
  timestep.hh
  trait.hh
  trackpoint.hh
  transform.hh
  transformmock.hh
  transformio.hh
  transformfactory.hh
  vector.hh
  vectorfield.hh
  vfio.hh
  vfregularizer.hh
  vfregularizerkernel.hh
  )

SET(MIA2D_HEADERS ${MIA2D_HEADERS_BASE} ${SEG_HEADER} ${ITPP_HEADER})

#
# the main 2D library
# 
MIA_ADD_LIBRARY(mia2d "${MIA2D_SRC}" miacore)

#
# What we need to link from here on 
#
SET(MIA2DLIBS mia2d  ${LIBS})


#
# The test library: On MS windows it needs to be static, 
# because it doesen't resolve all
# symbols, and in Windows, this is not supported# 
SET(mia2dtestsrc 
  imageiotest.cc 
  vfiotest.cc 
  imagetest.cc
  transformmock.cc
  )
SET(mia2dlibdeps mia2d ${BOOST_UNITTEST})

MIA_ADD_LIBRARY(mia2dtest "${mia2dtestsrc}" "${mia2dlibdeps}")
SET_TARGET_PROPERTIES(mia2dtest PROPERTIES COMPILE_FLAGS -DBOOST_TEST_DYN_LINK)


IF(APPLE)
   SET_TARGET_PROPERTIES(mia2dtest PROPERTIES LINK_FLAGS "-single_module -Wl,-flat_namespace -Wl,-undefined -Wl,suppress")
ENDIF(APPLE)

MACRO(TEST_2DMIA file libs)
  ADD_EXECUTABLE(test-2d-${file} test_${file}.cc)
  TARGET_LINK_LIBRARIES(test-2d-${file} ${libs} ${BOOST_UNITTEST} )
  ADD_TEST(2d-${file} test-2d-${file})
ENDMACRO(TEST_2DMIA file)

IF(MIA_ENABLE_TESTING) 
TEST_2DMIA(angle mia2d)
TEST_2DMIA(datafield mia2dtest)
TEST_2DMIA(image mia2dtest)
TEST_2DMIA(filter mia2dtest)
TEST_2DMIA(param mia2dtest)
TEST_2DMIA(vector mia2dtest)
TEST_2DMIA(boundingbox mia2dtest)
TEST_2DMIA(distance mia2dtest)
TEST_2DMIA(fullcost mia2dtest)
TEST_2DMIA(interpol mia2dtest)
TEST_2DMIA(matrix mia2dtest)
TEST_2DMIA(nfg mia2dtest)
TEST_2DMIA(cost mia2dtest)
TEST_2DMIA(iterator mia2dtest)
TEST_2DMIA(nonrigidregister mia2dtest)
TEST_2DMIA(oldnewintegrate mia2dtest)
TEST_2DMIA(combiner mia2dtest)
TEST_2DMIA(polygon mia2dtest)
TEST_2DMIA(ppmatrix mia2dtest)
TEST_2DMIA(rigidregister mia2dtest)
TEST_2DMIA(transformfactory mia2dtest)
TEST_2DMIA(vectorfield mia2dtest)
TEST_2DMIA(similarity_profile mia2dtest)
TEST_2DMIA(transio mia2d)
TEST_2DMIA(transform mia2dtest)
TEST_2DMIA(shape mia2dtest)
TEST_2DMIA(morphshape mia2dtest)
TEST_2DMIA(imageio mia2dtest)
TEST_2DMIA(sparse_image_solver mia2dtest)
TEST_2DMIA(filter_cast mia2d)
TEST_2DMIA(splinetransformpenalty mia2d)
TEST_2DMIA(trackpoint mia2dtest)
ENDIF()

IF(CMAKE_BUILD_TYPE)
  SET(CONFIG ${CMAKE_BUILD_TYPE})
ELSE(CMAKE_BUILD_TYPE)
  SET(CONFIG "NOCONFIG")
ENDIF(CMAKE_BUILD_TYPE)

#
# installation 
#
INSTALL_WITH_EXPORT(mia2d)
INSTALL_WITH_EXPORT(mia2dtest)

INSTALL(FILES ${MIA2D_HEADERS} DESTINATION ${INCLUDE_INSTALL_PATH}/mia/2d)



SET(MIA2D_MYOCARDPERF_SRC 
  ${SEG_SRC}
  ground_truth_evaluator.cc
  groundtruthproblem.cc
  ica.cc 
  perfusion.cc
  )  

SET(MIA2D_MYOCARDPERF_HEADER 
  ${SEG_HEADER}
  ground_truth_evaluator.hh
  groundtruthproblem.hh
  ica.hh
  perfusion.hh
  )  

MIA_ADD_LIBRARY(mia2dmyocardperf "${MIA2D_MYOCARDPERF_SRC}" mia2d)

INSTALL_WITH_EXPORT(mia2dmyocardperf)
INSTALL(FILES ${MIA2D_MYOCARDPERF_HEADER} DESTINATION ${INCLUDE_INSTALL_PATH}/mia/2d)

IF(ITPP_FOUND)
  TEST_2DMIA(ica mia2dmyocardperf)
  TEST_2DMIA(perfusion mia2dmyocardperf)
ENDIF(ITPP_FOUND)

set(testperflibs mia2dmyocardperf mia2dtest)

IF(MIA_ENABLE_TESTING)
TEST_2DMIA(groundtruthproblem mia2dmyocardperf)
TEST_2DMIA(correlation_weight mia2dmyocardperf)
TEST_2DMIA(segmentation mia2dmyocardperf)
TEST_2DMIA(segframe "${testperflibs}")
TEST_2DMIA(segpoint mia2dmyocardperf)
ENDIF()


#
# The plugin directories 
#
ADD_SUBDIRECTORY(cost      )
ADD_SUBDIRECTORY(combiner  )
ADD_SUBDIRECTORY(creator   )
ADD_SUBDIRECTORY(io        )
ADD_SUBDIRECTORY(filter    )
ADD_SUBDIRECTORY(fft       )
ADD_SUBDIRECTORY(fullcost  )
ADD_SUBDIRECTORY(kernel    )
ADD_SUBDIRECTORY(model     )
ADD_SUBDIRECTORY(maskedcost)
ADD_SUBDIRECTORY(rgbio     )
ADD_SUBDIRECTORY(shapes    )
#ADD_SUBDIRECTORY(sparseimgsolver )
ADD_SUBDIRECTORY(timestep  )
ADD_SUBDIRECTORY(transform )
ADD_SUBDIRECTORY(transio )
ADD_SUBDIRECTORY(splinepenalty )
ADD_SUBDIRECTORY(vfregularizer )
ADD_SUBDIRECTORY(vfregularizerkernel )

=== mia/3d/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2016 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

SET(MIA3D_SRC 
  affine_matrix.cc
  camera.cc
  cost.cc
  creator.cc
  critical_point.cc
  2dimagefifofilter.cc
  datafield.cc
  distance.cc
  filter.cc
  fullcost.cc
  fuzzyseg.cc
  fuzzyclustersolver_cg.cc
  ica.cc 
  image.cc
  imagedraw.cc
  imageio.cc
  imagecollect.cc
  interpolator.cc
  landmark.cc
  landmarklist.cc
  landmarklistio.cc
  maskedcost.cc
  matrix.cc 
  model.cc
  multicost.cc
  nfg.cc 
  nonrigidregister.cc
  orientation.cc
  ppmatrix.cc 
  quaternion.cc
  register.cc
  rigidregister.cc
  rot.cc
  shape.cc
  similarity_profile.cc
  splinetransformpenalty.cc
  stackdisttrans.cc
  timestep.cc
  trackpoint.cc
  transform.cc
  transformfactory.cc
  transformio.cc
  vectorfield.cc
  vfregularizer.cc
  vfregularizerkernel.cc
  vfio.cc
  )

SET(MIA3D_HEADERS
  affine_matrix.hh
  2dimagefifofilter.hh
  datafield.hh datafield.cxx
  image.hh
  filter.hh
  ica.hh
  imagedraw.cc
  imageio.hh
  imagetest.hh
  imageiotest.hh
  camera.hh
  cost.hh
  creator.hh
  critical_point.hh
  defines3d.hh
  deformer.hh
  distance.hh
  fifotestfixture.hh
  fullcost.hh
  fuzzyseg.hh
  fuzzyclustersolver_cg.hh
  interpolator.hh interpolator.cxx
  iterator.hh iterator.cxx
  ica.hh
  imagecollect.hh
  landmark.hh
  landmarklist.hh
  landmarklistio.hh
  maskedcost.hh
  matrix.hh
  model.hh
  multicost.hh
  multireg.hh
  nfg.hh
  nonrigidregister.hh
  orientation.hh
  ppmatrix.hh
  quaternion.hh
  register.hh
  rigidregister.hh
  rot.hh
  shape.hh
  similarity_profile.hh
  stackdisttrans.hh
  splinetransformpenalty.hh
  timestep.hh
  trackpoint.hh
  trait.hh
  transform.hh
  transformfactory.hh
  transformio.hh
  transformmock.hh
  valueattributetranslator.hh
  vector.hh
  vectorfield.hh
  vfregularizer.hh
  vfregularizerkernel.hh
  vfio.hh
  vfiotest.hh
  )

SET(MIA3DTEST_SRC
  test_3d.cc
  test_datafield.cc
  test_image.cc
  test_vector.cc
  test_interpol.cc
  )



#
# The main 3D library
#
MIA_ADD_LIBRARY(mia3d "${MIA3D_SRC}" mia2d)

MACRO(TEST_3D name)
  ADD_EXECUTABLE(test-3d-${name} test_${name}.cc)  
  TARGET_LINK_LIBRARIES(test-3d-${name} mia3dtest ${BOOST_UNITTEST})
  ADD_TEST(3d-${name} test-3d-${name})
  IF(WIN32)
    SET_TARGET_PROPERTIES(test-3d-${name} PROPERTIES LINKER_FLAGS "/NODEFAULTLIB:MSVCRT")
  ENDIF(WIN32)
ENDMACRO(TEST_3D name)


SET(MIA3DLIBS mia3d  ${LIBS})
#
# io test library 
#

SET(mia3dtestsrc 
  imageiotest.cc 
  imagetest.cc 
  vfiotest.cc 
  fifotestfixture.cc
  transformmock.cc
  )
SET(mia3dtestdeps ${MIA3DLIBS} mia2dtest ${BOOST_UNITTEST})

MIA_ADD_LIBRARY(mia3dtest "${mia3dtestsrc}" "${mia3dtestdeps}")
SET_TARGET_PROPERTIES(mia3dtest PROPERTIES COMPILE_FLAGS -DBOOST_TEST_DYN_LINK)

IF(APPLE)
  SET_TARGET_PROPERTIES(mia3dtest PROPERTIES LINK_FLAGS "-single_module -Wl,-flat_namespace -Wl,-undefined -Wl,suppress")
ENDIF(APPLE)

#
# Testing 
#
IF(MIA_ENABLE_TESTING)
ADD_EXECUTABLE(test-3d ${MIA3DTEST_SRC})
SET_TARGET_PROPERTIES(test-3d PROPERTIES COMPILE_FLAGS -DBOOST_TEST_DYN_LINK)
TARGET_LINK_LIBRARIES(test-3d mia3dtest ${MIA3DLIBS} ${BOOST_UNITTEST})

SET(TEST_3D test-3d)

IF (WIN32)
  ADD_TEST(3d "${CMAKE_CURRENT_SOURCE_DIR}/test-3d.bat")
ELSE (WIN32)
  ADD_TEST(3d test-3d)
ENDIF(WIN32)

TEST_3D(affine_matrix affine_matrix)
TEST_3D(critical_points)
TEST_3D(2dimagefifofilter imagefifofilter)
TEST_3D(nfg nfg)
TEST_3D(vectorfield vectorfield)
TEST_3D(orientation orientation)
TEST_3D(deform deform)
TEST_3D(ica ica)
TEST_3D(transformfactory transformfactory)
TEST_3D(rigidregister rigidregister)
TEST_3D(nonrigidregister nonrigidregister)
TEST_3D(transform transform)
TEST_3D(transio transio)
TEST_3D(landmark landmark)
TEST_3D(landmarklistio landmarklistio)
TEST_3D(quaternion quaternion)
TEST_3D(ppmatrix ppmatrix)
TEST_3D(matrix matrix)
TEST_3D(fullcost fullcost)
TEST_3D(iterator iterator)
TEST_3D(stackdisttrans stackdisttrans)
TEST_3D(similarity_profile similarity_profile)
TEST_3D(trackpoint similarity_profile)
TEST_3D(distance distance)
TEST_3D(imagecollect imagecollect)
TEST_3D(imagedraw imagedraw)
TEST_3D(rot rot)
TEST_3D(splinetransformpenalty splinetransformpenalty)

TEST_3D(imageio imageio)
ENDIF()
#
# installation 
#
SET(INSTALL_TARGETS mia3d mia3dtest)	
INSTALL_WITH_EXPORT("${INSTALL_TARGETS}")
INSTALL(FILES ${MIA3D_HEADERS} DESTINATION ${INCLUDE_INSTALL_PATH}/mia/3d)

#
# sub directories (plugins) 
#
ADD_SUBDIRECTORY(cost     )
ADD_SUBDIRECTORY(combiner )
ADD_SUBDIRECTORY(creator  )
ADD_SUBDIRECTORY(filter   )
ADD_SUBDIRECTORY(fifof    )
ADD_SUBDIRECTORY(fullcost )
ADD_SUBDIRECTORY(io       )
ADD_SUBDIRECTORY(lmio)
ADD_SUBDIRECTORY(maskedcost )
ADD_SUBDIRECTORY(reg3d    )
ADD_SUBDIRECTORY(shapes   )
ADD_SUBDIRECTORY(splinepenalty  )
ADD_SUBDIRECTORY(transform)
ADD_SUBDIRECTORY(transio)
ADD_SUBDIRECTORY(vfregularizerkernel)
ADD_SUBDIRECTORY(vfregularizer)

=== src/isosurface/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

SET(miagts_SOURCES 
  iso_backend.cc  mesh_convert.cc
  )

OPTION(WITH_GTS "Use the GNU Triangulated Surfaces Library for some mesh realted features" ${SEARCH_LIBS_DEFAULT})

IF(WITH_GTS) 
  IF(STRICT_DEPENDECIES) 
    pkg_check_modules(GTS gts REQUIRED)
  ELSE(STRICT_DEPENDECIES) 
    pkg_check_modules(GTS gts)
  ENDIF(STRICT_DEPENDECIES) 
ENDIF(WITH_GTS) 

IF(GTS_FOUND) 
  INCLUDE_DIRECTORIES(${GTS_INCLUDE_DIRS})
  set( miagts_DEPS miamesh ${GTS_LIBRARIES})
  MIA_ADD_LIBRARY(miagts "${miagts_SOURCES}" "${miagts_DEPS}")
  INSTALL_WITH_EXPORT(miagts)

  # add the ISO-surface programs 
  ADD_EXECUTABLE(mia-3disosurface-from-volume iso.cc)
  ADD_DEPENDENCIES(mia-3disosurface-from-volume plugin_test_links)
  MIA_EXE_CREATE_DOCU_AND_INTERFACE(mia 3disosurface-from-volume)
  TARGET_LINK_LIBRARIES(mia-3disosurface-from-volume miagts)
  INSTALL(TARGETS mia-3disosurface-from-volume RUNTIME DESTINATION "bin")

  ADD_EXECUTABLE(mia-3disosurface-from-stack iso_from_slices.cc)
  ADD_DEPENDENCIES(mia-3disosurface-from-stack plugin_test_links)
  MIA_EXE_CREATE_DOCU_AND_INTERFACE(mia 3disosurface-from-stack)
  TARGET_LINK_LIBRARIES(mia-3disosurface-from-stack miagts)
  INSTALL(TARGETS mia-3disosurface-from-stack RUNTIME DESTINATION "bin")

  # add GTS IO plug-in
  
  
ENDIF(GTS_FOUND)

=== examples/2d/filter/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

PLUGIN_WITH_TEST_AND_PREFIX_NOINST(2d-filter "simple" "${MIA2DLIBS}"  TESTLIBS  mia2dtest)

=== mia/2d/combiner/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2015 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

SET(combiners
  ops)

PLUGINGROUP_WITH_TEST_AND_PREFIX2("2dimage" "combiner" "${combiners}" "${MIA2DLIBS}")

=== debian/changelog ===
mia (2.4.6-5build3) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 21:03:05 +0000

mia (2.4.6-5build2) focal; urgency=medium

  * No-change rebuild against libopenexr24.

 -- Rik Mills <rikmills@kde.org>  Mon, 02 Dec 2019 07:39:37 +0000

mia (2.4.6-5build1) focal; urgency=medium

  * No-change rebuild against libvtk7.1p

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 06 Nov 2019 05:21:13 +0000

mia (2.4.6-5) unstable; urgency=medium

  [ Jelmer Vernooĳ ]
  * Trim trailing whitespace.

  [ Gert Wollny ]
  * d/control: Switch dependencies to python3 Closes: #943114

 -- Gert Wollny <gewo@debian.org>  Wed, 23 Oct 2019 11:00:04 +0200

mia (2.4.6-4) unstable; urgency=medium

  * d/control, d/compat: Update to version 12~ and standards 4.3
  * d/rules: remove dh_builddeb -- -Z xz

 -- Gert Wollny <gewo@debian.org>  Sat, 12 Jan 2019 19:20:36 +0100

mia (2.4.6-3) unstable; urgency=medium

  [ Andreas Tille ]
  * Remove invalid fields from debian/upstream/metadata
  * Remove Watch field from debian/upstream/metadata

  [ Gert Wollny ]
  * d/*: run cme fix dpkg
    - fix VCS urls
    - fix d/copyright format URL
  * d/control: build using libvtk7-dev
  * d/* update standards to 4.2.1 (no changes needed)

 -- Gert Wollny <gewo@debian.org>  Sun, 09 Sep 2018 19:51:10 +0200

mia (2.4.6-2) unstable; urgency=medium

  * d/p/mia_226_glibc_227: use numeric_limits::max() Closes: #891337
  * d/rules: drop superfluous --parallel in dh command

 -- Gert Wollny <gewo@debian.org>  Tue, 06 Mar 2018 11:21:28 +0100

mia (2.4.6-1) unstable; urgency=medium

  * New upstream version 2.4.6

 -- Gert Wollny <gewo@debian.org>  Sun, 05 Nov 2017 17:58:55 +0100

mia (2.4.5-1) unstable; urgency=medium

  * New upstream version 2.4.5
  * d/control: Update standards to 4.1.1  (no changes required)

 -- Gert Wollny <gewo@debian.org>  Mon, 16 Oct 2017 12:19:10 +0200

=== debian/control ===
Source: mia
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Gert Wollny <gewo@debian.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper (>= 12~),
               libblas-dev,
               libboost-filesystem-dev,
               libboost-serialization-dev,
               libboost-system-dev,
               libboost-test-dev,
               libdcmtk-dev,
               libeigen3-dev,
               libfftw3-dev,
               libgsl-dev,
               libgts-dev,
               libitpp-dev,
               libhdf5-dev,
               libmaxflow-dev,
               libnifti-dev,
               libnlopt-dev,
               libopenexr-dev,
               libpng-dev,
               libtiff-dev,
               libvtk7-dev,
               libvistaio-dev,
               libxml2-dev,
               python3-lxml
Build-Depends-Indep: docbook-xsl,
                     doxygen,
                     graphviz,
                     libjs-mathjax,
                     xsltproc
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/med-team/mia
Vcs-Git: https://salsa.debian.org/med-team/mia.git
Homepage: http://mia.sourceforge.net

Package: libmia-2.4-4
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Breaks: libmia-2.4-0
Replaces: libmia-2.4-0
Description: library for 2D and 3D gray scale image processing
 libmia comprises a set of libraries and plug-ins for general purpose
 2D and 3D gray scale image processing and basic handling of triangular
 meshes. The libraries provide a basic infrastructure and  generic
 algorithms, that can be specialized by specifying the appropriate plug-ins.

Package: libmia-2.4-dev
Architecture: any
Section: libdevel
Depends: libmia-2.4-4 (= ${binary:Version}),
         mia-doctools (= ${source:Version}),
         libitpp-dev,
         libgsl-dev,
         libboost-test-dev,
         libfftw3-dev,
         libblas-dev,
         ${misc:Depends}
Recommends: libmia-2.4-doc
Conflicts: libmia-2.2-dev
Replaces: libmia-2.2-dev
Description: library for 2D and 3D gray scale image processing, development files
 libmia comprises a set of libraries and plug-ins for general purpose
 2D and 3D gray scale image processing and basic handling of triangular
 meshes. The libraries provide a basic infrastructure and  generic
 algorithms, that can be specialized by specifying the appropriate plug-ins.
 This package provides the development files for the library.

Package: libmia-2.4-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-mathjax
Enhances: libmia-2.4-dev
Conflicts: libmia-2.2-doc
Replaces: libmia-2.2-doc
Description: library for 2D and 3D gray scale image processing, documentation
 libmia comprises a set of libraries and plug-ins for general purpose
 2D and 3D gray scale image processing and basic handling of triangular
 meshes. The libraries provide a basic infrastructure and  generic
 algorithms, that can be specialized by specifying the appropriate plug-ins.
 This package provides the Doxygen generated API reference.

Package: mia-tools
Architecture: any
Depends: libmia-2.4-4 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: mia-tools-doc
#Suggests: python-nipype
Description: Command line tools for gray scale image processing
 Command lines tools to run general purpose image processing tasks on 2D
 and 3D gray scale images, and basic operations on triangular meshes.
 Supported image processing algorithms are image filtering, combining, image
 registration, motion compensation for image series, and the estimation of
 various statistics over images.
 This package also contains the nipype interfaces for these command line tools.

Package: mia-doctools
Architecture: all
Depends: python3-lxml,
         python3,
         ${misc:Depends}
Conflicts: libmia-2.2-dev
Description: Helper scripts for run-time document creation
 A set of scripts that can be used to create man-pages and on-line
 documentation for programs that make use of the mia command line
 parser and plug-in infrastructure

Package: mia-tools-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Enhances: mia-tools
Description: Cross-referenced documentation of the MIA command line tools
 Cross referenced documentation of the command line tools and plug-ins that
 are provided by the MIA gray scale image processing tool chain.
 These lines tools to provide the means to run general purpose image
 processing tasks on 2D and 3D gray scale images, and basic operations on
 triangular meshes interactively from the command line. Supported image
 processing algorithms are image filtering, combining, image registration,
 motion compensation for image series, and the estimation of various
 statistics over images.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
 

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed -fvisibility=hidden

# reduce debug info to fix FTBFS on archs with low address space
ifneq (,$(filter $(DEB_HOST_ARCH), mips mipsel))
  export DEB_CFLAGS_MAINT_APPEND = -g1
  export DEB_CXXFLAGS_MAINT_APPEND = -g1
endif

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# deduce documentation option (build-indep target)
ifeq "" "$(filter %-doc,$(shell dh_listpackages))"
  BUILDDOC = OFF
else
  BUILDDOC = ON
endif


.PHONY: override_dh_strip override_dh_shlibdeps override_dh_auto_test

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	-DALWAYS_CREATE_DOC=$(BUILDDOC)  \
	-DSTRICT_DEPENDECIES=ON \
	-DMIA_CREATE_MANPAGES=ON \
	-DMIA_CREATE_USERDOC=$(BUILDDOC) \
	-DMIA_CREATE_NIPYPE_INTERFACES=ON

# dh_strip detects executable files, so make *.mia files executable then strip then 
# remove the executable flag 
override_dh_strip:
	`pwd`/debian/run_strip

override_dh_auto_build-indep: 
	dh_auto_build -- doc

override_dh_auto_build-arch: 
	dh_auto_build

override_dh_shlibdeps:
	dh_shlibdeps -- $(shell find  debian/libmia-2.4-4/ -name "*.mia")

=== debian/watch ===
version=4
opts="pgpsigurlmangle=s/$/.asc/" http://sf.net/mia/mia-([\d.]+)\.tar\.xz
